Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ResourceFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ResourceFactory.java	(revision 1095)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ResourceFactory.java	(revision 1207)
@@ -1,79 +1,20 @@
 package schedframe.resources.computing;
 
-import schedframe.resources.CoolEmAllResourceType;
 import schedframe.resources.StandardResourceType;
 import schedframe.resources.computing.description.ComputingResourceDescription;
-import schedframe.resources.computing.recs.ComputeBox1;
-import schedframe.resources.computing.recs.Node;
-import schedframe.resources.computing.recs.NodeGroup;
 import schedframe.scheduling.Scheduler;
 import schedframe.scheduling.manager.resources.ManagedResources;
 import schedframe.scheduling.plugin.SchedulingPlugin;
 import schedframe.scheduling.plugin.estimation.ExecutionTimeEstimationPlugin;
-import schedframe.scheduling.policy.AbstractManagementSystem;
-import schedframe.scheduling.policy.global.GridBroker;
-import schedframe.scheduling.policy.local.LocalManagementSystem;
 import schedframe.scheduling.queue.TaskQueueList;
-import simulator.DCWormsConstants;
 
 
-public class ResourceFactory {
+public interface ResourceFactory {
 
-	public static ComputingResource createResource(ComputingResourceDescription resDesc){
-		
-		if (resDesc.getType().equals(StandardResourceType.DataCenter))
-			return new DataCenter(resDesc);
-		else if (resDesc.getType().equals(StandardResourceType.Rack))
-			return new Rack(resDesc);
-		else if (resDesc.getType().equals(StandardResourceType.ComputingNode))
-			return new ComputingNode(resDesc);
-		else if (resDesc.getType().equals(StandardResourceType.Processor))
-			return new Processor(resDesc);
-		else if (resDesc.getType().equals(StandardResourceType.Core))
-			return new Core(resDesc);
-		else if (resDesc.getType().equals(CoolEmAllResourceType.ComputeBox1))
-			return new ComputeBox1(resDesc);
-		else if (resDesc.getType().equals(CoolEmAllResourceType.NodeGroup))
-			return new NodeGroup(resDesc);
-		else if (resDesc.getType().equals(CoolEmAllResourceType.Node))
-			return new Node(resDesc);
-		else if (resDesc.getType().equals(CoolEmAllResourceType.Processor))
-			return new Processor(resDesc);
-		else if (resDesc.getType().equals(CoolEmAllResourceType.Core))
-			return new Core(resDesc);
-		else
-			return new ComputingResource(resDesc);
+	public ComputingResource createComputingResource(ComputingResourceDescription resDesc);
+
+	//public Device createDevice(DeviceDescription devDesc);
 	
-		/*switch(resDesc.getType()){
-			case Grid: return new Grid(resDesc);
-			case DataCenter: return new DataCenter(resDesc);
-			case ComputingNode: return new ComputingNode(resDesc);
-			case Processor: return new Processor(resDesc);
-		default:
-			return new ComputingResource(resDesc);
-		}*/
-	}
-
-	public static Scheduler createScheduler(StandardResourceType type, String id, SchedulingPlugin schedulingPlugin, ExecutionTimeEstimationPlugin execTimeEstimationPlugin, TaskQueueList queues, ManagedResources managedResources) throws Exception{
-		AbstractManagementSystem ms;
-		switch(type){
-			case GS: {
-				ms = new GridBroker("grid",
-						schedulingPlugin, execTimeEstimationPlugin, queues);
-				return new Scheduler(ms, type, managedResources);
-			}
-			case LS: {
-				ms = new LocalManagementSystem(id, DCWormsConstants.MANAGEMENT_SYSTEM,
-						schedulingPlugin, execTimeEstimationPlugin, queues);
-				return new Scheduler(ms, type, managedResources);
-			}
-
-		default:{
-				ms = new LocalManagementSystem(id, DCWormsConstants.MANAGEMENT_SYSTEM,
-						schedulingPlugin, execTimeEstimationPlugin, queues);
-				return new Scheduler(ms, type, managedResources);
-			}
-		}
-	}
+	public Scheduler createScheduler(StandardResourceType type, String id, SchedulingPlugin schedulingPlugin, ExecutionTimeEstimationPlugin execTimeEstimationPlugin, TaskQueueList queues, ManagedResources managedResources) throws Exception;
 }
 
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Processor.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Processor.java	(revision 883)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Processor.java	(revision 1207)
@@ -9,6 +9,4 @@
 import schedframe.resources.computing.extensions.ExtensionType;
 import schedframe.resources.computing.profiles.energy.EnergyExtension;
-import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
-import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 import schedframe.resources.computing.profiles.energy.power.ui.ProcessorPowerInterface;
 import schedframe.resources.computing.properties.CpuPropertiesBuilder;
@@ -27,7 +25,15 @@
 	}
 
-
-	public ComputingNode getComputingNode(){
-		return (ComputingNode)parent;
+	public ComputingNode getNode(){
+		ComputingResource compRes = parent;
+		while(compRes != null && !compRes.getType().equals(StandardResourceType.Node)){
+			compRes = compRes.getParent();
+		}
+		ComputingNode compNode = null;
+		try{
+			compNode = (ComputingNode)compRes;
+		} catch(Exception e) {
+		}
+		return compNode;
 	}
 	
@@ -63,5 +69,5 @@
 
 	private CpuSpeed getSpeedUnit() throws NoSuchFieldException{
-		return (CpuSpeed) resourceCharacteristic.getResourceUnit(StandardResourceUnitName.CPUSPEED);
+		return (CpuSpeed) ((ComputingResourceCharacteristics)resourceCharacteristic).getResourceUnit(StandardResourceUnitName.CPUSPEED);
 	}
 	
@@ -80,7 +86,7 @@
 		super.initCharacteristics(resDesc);
 		try{
-			resourceCharacteristic.addResourceUnit(new CpuSpeed(name, Integer.valueOf(resDesc.getCompResourceParameterValue("speed")) * 1, 0));
+			((ComputingResourceCharacteristics)resourceCharacteristic).addResourceUnit(new CpuSpeed(name, Integer.valueOf(resDesc.getCompResourceParameterValue("speed")) * 1, 0));
 		} catch(Exception e){
-			resourceCharacteristic.addResourceUnit(new CpuSpeed(name,  1, 0));
+			((ComputingResourceCharacteristics)resourceCharacteristic).addResourceUnit(new CpuSpeed(name,  1, 0));
 		}
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Rack.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Rack.java	(revision 756)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Rack.java	(revision 1207)
@@ -5,7 +5,4 @@
 import schedframe.resources.StandardResourceType;
 import schedframe.resources.computing.description.ComputingResourceDescription;
-import schedframe.resources.computing.profiles.energy.EnergyExtension;
-import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
-import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 
 public class Rack extends ComputingResource{
@@ -20,5 +17,5 @@
 	@SuppressWarnings("unchecked")
 	public List<ComputingNode> getComputingNodes(){
-		return (List<ComputingNode>) getDescendantsByType(StandardResourceType.ComputingNode);
+		return (List<ComputingNode>) getDescendantsByType(StandardResourceType.Node);
 	}
 	
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ResourceCharacteristics.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ResourceCharacteristics.java	(revision 1007)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ResourceCharacteristics.java	(revision 1207)
@@ -1,13 +1,6 @@
 package schedframe.resources.computing;
-
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
 
 import schedframe.Parameters;
 import schedframe.resources.computing.location.Location;
-import schedframe.resources.units.ResourceUnit;
-import schedframe.resources.units.ResourceUnitName;
 
 
@@ -16,7 +9,8 @@
 	private static final long serialVersionUID = 2719535186621622647L;
 
-	protected Map<ResourceUnitName, List<ResourceUnit>> resUnits;
+	protected Location location;
 	protected Parameters parameters;
-	protected Location location;
+	//protected Location location;
+	//protected List<Device> devices;
 
 	/*public ResourceCharacteristics(Map<ResourceUnitName, List<AbstractResourceUnit>> resUnits){
@@ -32,54 +26,6 @@
 	}*/
 	
-	public Map<ResourceUnitName, List<ResourceUnit>> getResourceUnits() {
-		if(resUnits == null)
-			return new HashMap<ResourceUnitName, List<ResourceUnit>>();
-		return resUnits;
-	}
+
 	
-	public ResourceUnit getResourceUnit(ResourceUnitName unitName) throws NoSuchFieldException{
-		if(getResourceUnits().containsKey(unitName))
-			return getResourceUnits().get(unitName).get(0);
-		else throw new NoSuchFieldException("Resource unit " + unitName + 
-				" is not available in this resource ");
-	}
-	
-	public void addResourceUnit(ResourceUnit unit){ 
-		if(resUnits == null){
-			resUnits = new HashMap<ResourceUnitName, List<ResourceUnit>>(2);
-		}
-		List<ResourceUnit> list = null;
-		if(resUnits.containsKey(unit.getName())){
-			list = resUnits.get(unit.getName());
-		} else {
-			list = new ArrayList<ResourceUnit>(1);
-			resUnits.put(unit.getName(), list);
-		}
-		list.add(unit);
-	}
-	
-	
-	public static class Builder {
-		  
-		protected Map<ResourceUnitName, List<ResourceUnit>> resUnits;
-		protected Location location;
-		protected Parameters parameters;
-		
-		public Builder location(Location loc){this.location = loc; return this; }
-        public Builder parameters(Parameters params){this.parameters = params; return this; }
-        public Builder resourceUnits(Map<ResourceUnitName, List<ResourceUnit>> units){this.resUnits = units; return this; }
-        public Builder resourceUnits(){this.resUnits = new HashMap<ResourceUnitName, List<ResourceUnit>>(2); return this; }
-        
-        public ResourceCharacteristics build() {
-            return new ResourceCharacteristics(this);
-        }
-	}
-	
-	private ResourceCharacteristics(Builder builder) {
-		this.location = builder.location;
-		this.parameters = builder.parameters;
-		this.resUnits = builder.resUnits;
-	}
-
 	public Parameters getParameters() {
 		if(parameters == null)
@@ -91,4 +37,56 @@
 		return location;
 	}
+	
+	protected ResourceCharacteristics(Builder<?> builder) {
+		//this.location = builder.location;
+		this.parameters = builder.parameters;
+		this.location = builder.location;
+		//this.devices = builder.devices;
+	}
+	
+    public static abstract class Builder<T extends Builder<T>> {
+  	  
+		protected Location location;
+		protected Parameters parameters;
+
+        public T parameters(Parameters params){this.parameters = params; return self(); }
+		public T location(Location loc){this.location = loc; return self(); }
+		
+        protected abstract T self();
+
+        public ResourceCharacteristics build() {
+            return new ResourceCharacteristics(this);
+        }
+    }
+    private static class Builder2 extends Builder<Builder2> {
+        @Override
+        protected Builder2 self() {
+            return this;
+        }
+    }
+
+    public static Builder<?> builder() {
+        return new Builder2();
+    }
+	
+	/*public static class Builder {
+		  
+		protected Map<ResourceUnitName, List<ResourceUnit>> resUnits;
+		//protected Location location;
+		protected Parameters parameters;
+		//protected List<Device> devices;
+		
+		//public Builder location(Location loc){this.location = loc; return this; }
+        public Builder parameters(Parameters params){this.parameters = params; return this; }
+        //public Builder device(List<Device> dev){this.devices = dev; return this; }
+        public Builder resourceUnits(Map<ResourceUnitName, List<ResourceUnit>> units){this.resUnits = units; return this; }
+        public Builder resourceUnits(){this.resUnits = new HashMap<ResourceUnitName, List<ResourceUnit>>(2); return this; }
+        
+        public ResourceCharacteristics build() {
+            return new ResourceCharacteristics(this);
+        }
+	}
+	*/
+
 
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/ComputeBox1.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/ComputeBox1.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/ComputeBox1.java	(revision 1207)
@@ -0,0 +1,28 @@
+package schedframe.resources.computing.coolemall;
+
+import java.util.List;
+
+import schedframe.resources.CoolEmAllResourceType;
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.ComputingNode;
+import schedframe.resources.computing.Rack;
+import schedframe.resources.computing.description.ComputingResourceDescription;
+
+public class ComputeBox1 extends Rack{
+	
+	public ComputeBox1(ComputingResourceDescription resDesc) {
+		super(resDesc);
+	}
+
+	@SuppressWarnings("unchecked")
+	public List<NodeGroup> getNodesGroups(){
+		return (List<NodeGroup>) getDescendantsByType(CoolEmAllResourceType.NodeGroup);
+	}
+	
+	@SuppressWarnings("unchecked")
+	public List<ComputingNode> getNodes(){
+		return (List<ComputingNode>) getDescendantsByType(StandardResourceType.Node);
+	}
+
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/NodeGroup.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/NodeGroup.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/coolemall/NodeGroup.java	(revision 1207)
@@ -0,0 +1,26 @@
+package schedframe.resources.computing.coolemall;
+
+import java.util.List;
+
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Processor;
+import schedframe.resources.computing.description.ComputingResourceDescription;
+
+public class NodeGroup extends ComputingResource{
+	
+	public NodeGroup(ComputingResourceDescription resDesc) {
+		super(resDesc);
+	}
+
+	@SuppressWarnings("unchecked")
+	public List<Node> getNodes(){
+		return (List<Node>) getDescendantsByType(StandardResourceType.Node);
+	}
+	
+	@SuppressWarnings("unchecked")
+	public List<Processor> getProcessors(){
+		return (List<Processor>) getDescendantsByType(StandardResourceType.Processor);
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Core.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Core.java	(revision 756)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/Core.java	(revision 1207)
@@ -1,8 +1,6 @@
 package schedframe.resources.computing;
 
+import schedframe.resources.StandardResourceType;
 import schedframe.resources.computing.description.ComputingResourceDescription;
-import schedframe.resources.computing.profiles.energy.EnergyExtension;
-import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
-import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 import schedframe.resources.units.CpuSpeed;
 import schedframe.resources.units.StandardResourceUnitName;
@@ -18,5 +16,27 @@
 
 	public Processor getProcessor(){
-		return (Processor)parent;
+		ComputingResource compRes = parent;
+		while(compRes != null && !compRes.getType().equals(StandardResourceType.Processor)){
+			compRes = compRes.getParent();
+		}
+		Processor proc = null;
+		try{
+			proc = (Processor)compRes;
+		} catch(ClassCastException e) {
+		}
+		return proc;
+	}
+	
+	public ComputingNode getNode(){
+		ComputingResource compRes = parent;
+		while(compRes != null && !compRes.getType().equals(StandardResourceType.Node)){
+			compRes = compRes.getParent();
+		}
+		ComputingNode compNode = null;
+		try{
+			compNode = (ComputingNode)compRes;
+		} catch(ClassCastException e) {
+		}
+		return compNode;
 	}
 	
@@ -42,5 +62,5 @@
 
 	private CpuSpeed getSpeedUnit() throws NoSuchFieldException{
-		return (CpuSpeed) resourceCharacteristic.getResourceUnit(StandardResourceUnitName.CPUSPEED);
+		return (CpuSpeed) ((ComputingResourceCharacteristics)resourceCharacteristic).getResourceUnit(StandardResourceUnitName.CPUSPEED);
 	}
 
@@ -48,7 +68,7 @@
 		super.initCharacteristics(resDesc);
 		try{
-			resourceCharacteristic.addResourceUnit(new CpuSpeed(name, Integer.valueOf(resDesc.getCompResourceParameterValue("speed")) * 1, 0));
+			((ComputingResourceCharacteristics)resourceCharacteristic).addResourceUnit(new CpuSpeed(name, Integer.valueOf(resDesc.getCompResourceParameterValue("speed")) * 1, 0));
 		} catch(Exception e){
-			resourceCharacteristic.addResourceUnit(new CpuSpeed(name,  1, 0));
+			((ComputingResourceCharacteristics)resourceCharacteristic).addResourceUnit(new CpuSpeed(name,  1, 0));
 		}
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/StandardResourceFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/StandardResourceFactory.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/StandardResourceFactory.java	(revision 1207)
@@ -0,0 +1,64 @@
+package schedframe.resources.computing;
+
+import schedframe.resources.CoolEmAllResourceType;
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.description.ComputingResourceDescription;
+import schedframe.scheduling.Scheduler;
+import schedframe.scheduling.manager.resources.ManagedResources;
+import schedframe.scheduling.plugin.SchedulingPlugin;
+import schedframe.scheduling.plugin.estimation.ExecutionTimeEstimationPlugin;
+import schedframe.scheduling.policy.AbstractManagementSystem;
+import schedframe.scheduling.policy.global.GridBroker;
+import schedframe.scheduling.policy.local.LocalManagementSystem;
+import schedframe.scheduling.queue.TaskQueueList;
+import simulator.DCWormsConstants;
+
+public class StandardResourceFactory implements ResourceFactory {
+	
+	public ComputingResource createComputingResource(ComputingResourceDescription resDesc){
+		
+		if (resDesc.getType().equals(StandardResourceType.DataCenter))
+			return new DataCenter(resDesc);
+		else if (resDesc.getType().equals(StandardResourceType.Rack))
+			return new Rack(resDesc);
+		else if (resDesc.getType().equals(StandardResourceType.Node))
+			return new ComputingNode(resDesc);
+		else if (resDesc.getType().equals(StandardResourceType.Processor))
+			return new Processor(resDesc);
+		else if (resDesc.getType().equals(StandardResourceType.Core))
+			return new Core(resDesc);
+		else
+			return new ComputingResource(resDesc);
+	
+		/*switch(resDesc.getType()){
+			case Grid: return new Grid(resDesc);
+			case DataCenter: return new DataCenter(resDesc);
+			case ComputingNode: return new ComputingNode(resDesc);
+			case Processor: return new Processor(resDesc);
+		default:
+			return new ComputingResource(resDesc);
+		}*/
+	}
+
+	public Scheduler createScheduler(StandardResourceType type, String id, SchedulingPlugin schedulingPlugin, ExecutionTimeEstimationPlugin execTimeEstimationPlugin, TaskQueueList queues, ManagedResources managedResources) throws Exception{
+		AbstractManagementSystem ms;
+		switch(type){
+			case GS: {
+				ms = new GridBroker("grid",
+						schedulingPlugin, execTimeEstimationPlugin, queues);
+				return new Scheduler(ms, type, managedResources);
+			}
+			case LS: {
+				ms = new LocalManagementSystem(id, DCWormsConstants.MANAGEMENT_SYSTEM,
+						schedulingPlugin, execTimeEstimationPlugin, queues);
+				return new Scheduler(ms, type, managedResources);
+			}
+
+		default:{
+				ms = new LocalManagementSystem(id, DCWormsConstants.MANAGEMENT_SYSTEM,
+						schedulingPlugin, execTimeEstimationPlugin, queues);
+				return new Scheduler(ms, type, managedResources);
+			}
+		}
+	}
+}
